Attribute VB_Name = "modMain"
Option Explicit

Public Declare Function CreateThread Lib "kernel32" ( _
                        ByRef lpThreadAttributes As Any, _
                        ByVal dwStackSize As Long, _
                        ByVal lpStartAddress As Long, _
                        ByRef lpParameter As Any, _
                        ByVal dwCreationFlags As Long, _
                        ByRef lpThreadId As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" ( _
                        ByVal hObject As Long) As Long

' //
' // Create thread and create frmThread in that thread and set callback
' // function to pfn in that thread
' //
Sub SetCallback( _
    ByVal pfn As Long)
        
    CloseHandle CreateThread(ByVal 0&, 0, AddressOf ThreadProc, ByVal pfn, 0, 0)
        
End Sub

Private Function ThreadProc( _
                 ByVal pfn As Long) As Long
    Dim cFrm    As frmThread
    
    Set cFrm = New frmThread
    
    cFrm.Callback = pfn
    cFrm.Show vbModal
    
End Function

