VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Create thread in DLL and call function from EXE"
   ClientHeight    =   4650
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   6420
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   310
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   428
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Create"
      Height          =   795
      Left            =   2100
      TabIndex        =   0
      Top             =   1500
      Width           =   2295
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' //
' // It calls the exported function SetCallback which creates a thread with the forms and
' // then we can call ThreadProc function from the thread
' //

Option Explicit

Private Declare Function SetDllDirectoryW Lib "kernel32" (ByVal pszPath As Long) As Long
Private Declare Sub SetCallback Lib "CallbackThread.dll" (ByVal pfnCallback As Long)

Private Function MakeTrue( _
                 ByRef bValue As Boolean) As Boolean
    bValue = True
    MakeTrue = True
End Function

Private Sub cmdCreate_Click()
    Dim bIsInIDE As Boolean
    
    Debug.Assert MakeTrue(bIsInIDE)
    
    If bIsInIDE Then
        SetDllDirectoryW (StrPtr(App.Path & "\..\..\binaries"))
    End If
    
    If bIsInIDE Then
        ' // SetCallback InitCurrentThreadAndCallFunctionIDEProc(AddressOf ThreadProc, 4)
        ' // We can't use it in IDE because all the calls are translated to main thread
        ' // and we need to marshal reference.
    Else
        SetCallback AddressOf ThreadProc_
    End If
    
End Sub

Private Sub Form_Load()
    modMultiThreading.Initialize
End Sub

Private Sub Form_Unload(Cancel As Integer)
    modMultiThreading.Uninitialize
End Sub
