
DEFINE_GUID(IID__Form, 0x33AD4F39, 0x6699, 0x11CF, 0xB7, 0x0C, 0x00, 0xAA, 0x00, 0x60, 0xD3, 0x93);

struct _FormVtbl;

typedef struct _Form {
	CONST_VTBL struct _FormVtbl *lpVtbl;
} _Form;

typedef struct _FormVtbl {

	HRESULT ( STDMETHODCALLTYPE *QueryInterface ) (
		_Form *This,
		REFIID riid,
		void **ppvObject);
	ULONG ( STDMETHODCALLTYPE *AddRef ) (
		_Form * This);  
	ULONG ( STDMETHODCALLTYPE *Release ) (
		_Form * This);  
	HRESULT ( STDMETHODCALLTYPE *GetTypeInfoCount ) (
		_Form * This,
		UINT *pctinfo);  
	HRESULT ( STDMETHODCALLTYPE *GetTypeInfo ) (
		_Form * This,
		UINT iTInfo,
		LCID lcid,
		ITypeInfo **ppTInfo); 
	HRESULT ( STDMETHODCALLTYPE *GetIDsOfNames ) (
		_Form * This,
		REFIID riid,
		LPOLESTR *rgszNames,
		UINT cNames,
		LCID lcid,
		DISPID *rgDispId);
	HRESULT ( STDMETHODCALLTYPE *Invoke ) (
		_Form * This,
		DISPID dispIdMember,
		REFIID riid,
		LCID lcid,
		WORD wFlags,
		DISPPARAMS *pDispParams,
		VARIANT *pVarResult,
		EXCEPINFO *pExcepInfo,
		UINT *puArgErr);
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder1 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder2 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder3 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder4 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder5 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder6 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder7 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder8 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder9 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder10 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder11 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_Name ) (
	_Form * This,
		BSTR * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder12 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_Caption ) (
	_Form * This,
		BSTR * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Caption ) (
	_Form * This,
		BSTR _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_hWnd ) (
	_Form * This,
		long * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder13 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_BackColor ) (
	_Form * This,
		long * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_BackColor ) (
	_Form * This,
		long _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ForeColor ) (
	_Form * This,
		long * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_ForeColor ) (
	_Form * This,
		long _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Left ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Left ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Top ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Top ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Width ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Width ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Height ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Height ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Enabled ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Enabled ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_WindowState ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_WindowState ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_MousePointer ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_MousePointer ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FontName ) (
	_Form * This,
		BSTR * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FontName ) (
	_Form * This,
		BSTR _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FontSize ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FontSize ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FontBold ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FontBold ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FontItalic ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FontItalic ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FontStrikethru ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FontStrikethru ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FontUnderline ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FontUnderline ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_hDC ) (
	_Form * This,
		long * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder14 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_CurrentX ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_CurrentX ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_CurrentY ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_CurrentY ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ScaleLeft ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_ScaleLeft ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ScaleTop ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_ScaleTop ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ScaleWidth ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_ScaleWidth ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ScaleHeight ) (
	_Form * This,
		float * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_ScaleHeight ) (
	_Form * This,
		float _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ScaleMode ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_ScaleMode ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FontTransparent ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FontTransparent ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_DrawStyle ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_DrawStyle ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_DrawWidth ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_DrawWidth ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FillStyle ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FillStyle ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_FillColor ) (
	_Form * This,
		long * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_FillColor ) (
	_Form * This,
		long _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_DrawMode ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_DrawMode ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_AutoRedraw ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_AutoRedraw ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Picture ) (
	_Form * This,
		struct Picture * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *putref_Picture ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Picture ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_BorderStyle ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_BorderStyle ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Icon ) (
	_Form * This,
		struct Picture * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *putref_Icon ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Icon ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_LinkTopic ) (
	_Form * This,
		BSTR * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_LinkTopic ) (
	_Form * This,
		BSTR _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_LinkMode ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_LinkMode ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_MaxButton ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_MinButton ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ControlBox ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder15 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_Image ) (
	_Form * This,
		struct Picture * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder16 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_HasDC ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder17 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder18 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder19 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder20 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder21 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder22 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder23 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_Visible ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Visible ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Tag ) (
	_Form * This,
		BSTR * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Tag ) (
	_Form * This,
		BSTR _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_MDIChild ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder24 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_KeyPreview ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_KeyPreview ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ClipControls ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_ClipControls ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_HelpContextID ) (
	_Form * This,
		long * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_HelpContextID ) (
	_Form * This,
		long _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_ActiveControl ) (
	_Form * This,
		struct Control * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder25 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder26 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder27 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder28 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder29 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder30 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder31 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder32 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder33 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_Count ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder34 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_Controls ) (
	_Form * This,
		IDispatch * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get__Default ) (
	_Form * This,
		IDispatch * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_MouseIcon ) (
	_Form * This,
		struct Picture * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *putref_MouseIcon ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_MouseIcon ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder35 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder36 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder37 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder38 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder39 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder40 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder41 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_Font ) (
	_Form * This,
		struct Font * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *putref_Font ) (
	_Form * This,
		struct Font * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Appearance ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Appearance ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_WhatsThisButton ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder42 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_WhatsThisHelp ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder43 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_ShowInTaskbar ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder44 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_RightToLeft ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_RightToLeft ) (
	_Form * This,
		VARIANT_BOOL _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_StartUpPosition ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *_VtblGapPlaceholder45 ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *get_OLEDropMode ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_OLEDropMode ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Palette ) (
	_Form * This,
		struct Picture * * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *putref_Palette ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_Palette ) (
	_Form * This,
		struct Picture * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_PaletteMode ) (
	_Form * This,
		short * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *put_PaletteMode ) (
	_Form * This,
		short _arg1 );
	HRESULT ( STDMETHODCALLTYPE *get_Moveable ) (
	_Form * This,
		VARIANT_BOOL * _arg1 );
	HRESULT ( STDMETHODCALLTYPE *Refresh ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *Move ) (
	_Form * This,
		float Left,
		VARIANT Top,
		VARIANT Width,
		VARIANT Height );
	HRESULT ( STDMETHODCALLTYPE *SetFocus ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *ZOrder ) (
	_Form * This,
		VARIANT Position );
	HRESULT ( STDMETHODCALLTYPE *Show ) (
	_Form * This,
		VARIANT Modal,
		VARIANT OwnerForm );
	HRESULT ( STDMETHODCALLTYPE *Hide ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *PrintForm ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *PopupMenu ) (
	_Form * This,
		IDispatch * Menu,
		VARIANT Flags,
		VARIANT X,
		VARIANT Y,
		VARIANT DefaultMenu );
	HRESULT ( STDMETHODCALLTYPE *Circle ) (
	_Form * This,
		short Step,
		float X,
		float Y,
		float Radius,
		long Color,
		float Start,
		float End,
		float Aspect );
	HRESULT ( STDMETHODCALLTYPE *Cls ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *Line ) (
	_Form * This,
		short Flags,
		float X1,
		float Y1,
		float X2,
		float Y2,
		long Color );
	HRESULT ( STDMETHODCALLTYPE *PaintPicture ) (
	_Form * This,
		struct Picture * Picture,
		float X1,
		float Y1,
		VARIANT Width1,
		VARIANT Height1,
		VARIANT X2,
		VARIANT Y2,
		VARIANT Width2,
		VARIANT Height2,
		VARIANT Opcode );
	HRESULT ( STDMETHODCALLTYPE *Point ) (
	_Form * This,
		float X,
		float Y,
		long * _arg3 );
	HRESULT ( STDMETHODCALLTYPE *PSet ) (
	_Form * This,
		short Step,
		float X,
		float Y,
		long Color );
	HRESULT ( STDMETHODCALLTYPE *Scale ) (
	_Form * This,
		short Flags,
		VARIANT X1,
		VARIANT Y1,
		VARIANT X2,
		VARIANT Y2 );
	HRESULT ( STDMETHODCALLTYPE *ScaleX ) (
	_Form * This,
		float Width,
		VARIANT FromScale,
		VARIANT ToScale,
		float * _arg4 );
	HRESULT ( STDMETHODCALLTYPE *ScaleY ) (
	_Form * This,
		float Height,
		VARIANT FromScale,
		VARIANT ToScale,
		float * _arg4 );
	HRESULT ( STDMETHODCALLTYPE *TextWidth ) (
	_Form * This,
		BSTR Str,
		float * _arg2 );
	HRESULT ( STDMETHODCALLTYPE *TextHeight ) (
	_Form * This,
		BSTR Str,
		float * _arg2 );
	HRESULT ( STDMETHODCALLTYPE *ValidateControls ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *WhatsThisMode ) (
		_Form * This );
	HRESULT ( STDMETHODCALLTYPE *OLEDrag ) (
		_Form * This );

} _FormVtbl;


