
#include <windows.h>

int main(int argc, char **argv) {
	BSTR sMsg;
	HINSTANCE hLib = LoadLibrary("ShowForm.dll");
	IUnknown *pForm;
	IOleWindow *pWnd;
	HRESULT hr;
    MSG msg;
    BOOL bRet; 
	HWND hWnd;

	IUnknown* (__stdcall *ShowForm)(BSTR) = (IUnknown*(__stdcall*)(BSTR))GetProcAddress(hLib, "ShowForm");

	if (!ShowForm)
		return 1;

	sMsg = SysAllocString(L"Hello from dll!");
	
	pForm = ShowForm(sMsg);

	hr = pForm->lpVtbl->QueryInterface(pForm, &IID_IOleWindow, &pWnd);

	// Get HWND to track when form will be closed/hidden
	hr = pWnd->lpVtbl->GetWindow(pWnd, &hWnd);

	pWnd->lpVtbl->Release(pWnd);

	SysFreeString(sMsg);

    while((bRet = GetMessage(&msg, NULL, 0, 0 )) != 0)
    { 
        if (bRet == -1)
        {
            break;
        }
        else
        {
            TranslateMessage(&msg); 
            DispatchMessage(&msg); 
        }

		if (!IsWindowVisible(hWnd))
			break;
    } 

	pForm->lpVtbl->Release(pWnd);

	FreeLibrary(hLib);

	return 0;

}